package dev.fyloz.trial.colorrecipesexplorer.model

import com.fasterxml.jackson.annotation.JsonIgnore
import java.util.*
import javax.persistence.*

@Entity
@Table(name = "mix_material")
data class MixMaterial(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long?,

    @JsonIgnore
    @ManyToOne
    @JoinColumn(name = "mix_id")
    val mix: Mix,

    @ManyToOne
    @JoinColumn(name = "material_id")
    val material: Material,

    var quantity: Float
) : Model

// ==== DSL ====
fun mixMaterial(
    id: Long? = null,
    mix: Mix = mix(),
    material: Material = material(),
    quantity: Float = 0f,
    op: MixMaterial.() -> Unit = {}
) = MixMaterial(id, mix, material, quantity).apply(op)

