package dev.fyloz.trial.colorrecipesexplorer.model

import com.fasterxml.jackson.annotation.JsonIgnore
import java.util.*
import javax.persistence.*

@Entity
@Table(name = "recipe_step")
data class RecipeStep(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long?,

    @JsonIgnore
    @ManyToOne
    @JoinColumn(name = "recipe_id")
    val recipe: Recipe?,

    val message: String
) : Model


// ==== DSL ====
fun recipeStep(
    id: Long? = null,
    recipe: Recipe? = recipe(),
    message: String = "message",
    op: RecipeStep.() -> Unit = {}
) = RecipeStep(id, recipe, message).apply(op)
